/*
  +---------------------------------+
  |                                 |
  |   Special printing functions.   |
  |                                 |
  +---------------------------------+
*/
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include "timer.h"
#include "print.h"

/*
  +------------------------+
  |                        |
  |   printf with flush.   |
  |                        |
  +------------------------+
*/
void uprintf( char *fmt, ...)
{
    va_list ap;
    va_start( ap, fmt);
    vfprintf( stdout, fmt, ap);
    va_end( ap);
    fflush( stdout);
}

/*
  +-------------------------------------+
  |                                     |
  |   printf with flush and time tag.   |
  |                                     |
  +-------------------------------------+
*/
void tprintf( char *fmt, ...)
{
    va_list ap;
    va_start( ap, fmt);
    fprintf( stdout, "[%08ld] ", wallclock());
    vfprintf( stdout, fmt, ap);
    va_end( ap);
    fflush( stdout);
}

/*
  +-------------------------------------------+
  |                                           |
  |   Debug printf with flush and time tag.   |
  |                                           |
  +-------------------------------------------+
*/
int debug_print;
void dprintf( char *fmt, ...)
{
    if( debug_print ) {
        va_list ap;
        va_start( ap, fmt);
        fprintf( stdout, "[%08ld] ", wallclock());
        vfprintf( stdout, fmt, ap);
        va_end( ap);
        fflush( stdout);
    }
}
