/*
  +------------------------------+
  |                              |
  |   Time measuring function.   |
  |                              |
  +------------------------------+
*/
#ifndef TIMER_DEF
#define TIMER_DEF

typedef unsigned long ztime_t;

const ztime_t TICKS_PER_SECOND = 1000;

//
// Call this once at the start of the program.
// It sets a variable to trim off the excess seconds since
// whatever 1970.
//
void init_time();

//
// Returns wallclock time in milliseconds.
// This has only aprox 55 ms resolution on a PC
// (roughly 1/18.2 s I think).
//
ztime_t wallclock();

//
// Make a time string from ztime_t difference in milliseconds.
//
char *timestr( ztime_t diftime);

#endif
